// Copyright 2005 Greg Stanton
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "ProSystem.h"
#include "Sound.h"
#define SOUND_SOURCE "Sound.cpp"

uint sound_lenght;

unsigned char sound_buffer[SNDLENGTH];    // Sound buffer

/* LUDO: */
typedef unsigned short WORD;
typedef unsigned int   DWORD;
typedef struct { 
    WORD  wFormatTag; 
    WORD  nChannels; 
    DWORD nSamplesPerSec; 
    DWORD nAvgBytesPerSec; 
    WORD  nBlockAlign; 
    WORD  wBitsPerSample; 
    WORD  cbSize; 
} WAVEFORMATEX; 

//signed short pokeySample[SNDLENGTH];

# define WAVE_FORMAT_PCM 0

//static const WAVEFORMATEX SOUND_DEFAULT_FORMAT = {WAVE_FORMAT_PCM, 1, 44100, 44100, 1, 8, 0};
//static WAVEFORMATEX sound_format = {WAVE_FORMAT_PCM, 1, 22050, 22050, 1, 8, 0};

// ----------------------------------------------------------------------------
// Resample
// ----------------------------------------------------------------------------
//# define MAX_SAMPLE_SIZE 1920
bool sound_Store() {  
  int targetIndex = 0;
  while (targetIndex < 524) {
    sound_buffer[targetIndex] = tia_buffer[targetIndex]+128;
    targetIndex++;
  }

  if(cartridge_pokey) {
    targetIndex = 0;
    while(targetIndex < 524) {
      sound_buffer[targetIndex] += pokey_buffer[targetIndex];
      sound_buffer[targetIndex] = sound_buffer[targetIndex] / 2;
      targetIndex++;
    }
  }
  
  return true;
}


unsigned int targetIndex = 0;

void processSound(register unsigned char *buffer, register unsigned short n) {
  if(cartridge_pokey) {
    while (n) {
      *(buffer++) = (tia_buffer[targetIndex]+pokey_buffer[targetIndex])/2+128;
      targetIndex=(targetIndex>=524 ? 0 : targetIndex+1);
      n--;
    }
  }
  else {
    while (n) {
      *(buffer++) = tia_buffer[targetIndex]+128;
      targetIndex=(targetIndex>=524 ? 0 : targetIndex+1);
      n--;
    }
  }
}
